#include <NewPing.h>
#define TRIGGER_PINR  2
#define ECHO_PINR     3 
#define TRIGGER_PINL  8
#define ECHO_PINL     9
#define TRIGGER_PINF  10
#define ECHO_PINF     11
#define MAX_DISTANCE 255
NewPing sonarr(TRIGGER_PINR, ECHO_PINR, MAX_DISTANCE);
NewPing sonarl(TRIGGER_PINL, ECHO_PINL, MAX_DISTANCE);
NewPing sonarf(TRIGGER_PINF, ECHO_PINF  , MAX_DISTANCE);
#include <Servo.h> 
#define SPEED_1      5 
#define DIR_1        4
#define SPEED_2      6
#define DIR_2        7
const uint8_t PIN_LINE = 4; 
int sensr;
int sensl;
int sensf;
Servo ruler;

int val = 150;
float p = 0.5395;
//int d = 1.3;
int schet;
int errorStat = 0;
int rulenie(int,int,int);
void moveForvard(int,int);
void redLED(int power);
void yellowLED(int power);
int  sensLin;
int times = 0;
void setup()
{
 ruler.attach(13);
 for(int i = 4; i < 8; i++)     
        pinMode(i, OUTPUT);
 Serial.begin(9600);
 errorStat = sonarr.ping_cm() - sonarl.ping_cm();
 pinMode(A3, OUTPUT);
 pinMode(A2, OUTPUT);
 pinMode(A1, OUTPUT);
 pinMode(A0, OUTPUT);
}

void loop() {
  sensr = sonarr.ping_cm();
  sensl = sonarl.ping_cm();
  sensf = sonarf.ping_cm();
  sensLin = analogRead(PIN_LINE);
  int rul;
  //Serial.print("times = ");
  //Serial.println(times);
  times++;
    
  if(sensf > 30 || sensf == 0)
  {
    redLED(0);
    /*if(times > 150)
    {
      if(sensLin > 1022)
      {
      schet++;
      redLED(200);
      moveForvard(1, val);
      delay(20);
      }*/
    /*if(schet >= 7)
    {
      moveForvard(0, 100);
      delay(400);
      moveForvard(1, 0);
      for(int g = 0;g < 100;g++)
      {
        redLED(0);
        ruler.write(85);
        yellowLED(200);
        delay(10);
        yellowLED(0);
      }
    }*/
    rul = rulenie(sensr, sensl, errorStat);
    ruler.write(rul + 85);
    if(rul + 20 > 100 || rul + 20 < 5 )
    {
      moveForvard(1,150);
    }
    moveForvard(1,val);
  }
  else{
    moveForvard(0, 200);
    ruler.write(2*(rul - 60));
    delay(1000);
    ruler.write(rul + 20);
    
  }
}

//*********
int rulenie(int sensorRight, int sensorLeft, int es)
{
    int eold;
    int summaLeft = 0;
    int summaRight = 0;
    int sredLeft;
    int sredRight;
    if(sensorLeft == 0 || sensorLeft > 100)
    {
      sensorLeft = 100;
    } 
    if(sensorRight == 0 || sensorLeft > 100)
    {
      sensorRight = 100;
    } 
    int er = sensorLeft - sensorRight;
    int u = round(p*er);
    //Serial.print("Right = ");
    //Serial.print(sensorRight);
    //Serial.print("  Left = ");
    //Serial.print(sensorLeft);
    //Serial.print("  u = ");
    //Serial.println(u);
    Serial.println(sensLin);
    //eold = er;
    return(u);
}
void moveForvard(int dir, int velocity)
{
  digitalWrite(DIR_1, !dir);
  analogWrite(SPEED_1,velocity);
  digitalWrite(DIR_2, !dir);
  analogWrite(SPEED_2,velocity);
}
void yellowLED(int power)
{
  analogWrite(A3,power);
  analogWrite(A2,power);
}

void redLED(int power)
{
  analogWrite(A1,power);
  analogWrite(A0,power);
}

